using System;
using System.IO;
using System.Reflection;

[assembly: AssemblyTitle("JsonShaping")]
[assembly: AssemblyDescription("JsonShaping")]
[assembly: AssemblyConfiguration("")]
[assembly: AssemblyCompany("OTFT")]
[assembly: AssemblyProduct("JsonShaping")]
[assembly: AssemblyCopyright("© 2019 OTFT")]
[assembly: AssemblyTrademark("")]
[assembly: AssemblyVersion("1.0.0.0")]
[assembly: AssemblyFileVersion("1.0.0.0")]

class JsonShaping
{
	static void Main(string[] args)
	{
		if(args.Length == 0)
		{
			Console.WriteLine("コマンドライン引数にjsonファイルを入れて下さい。");
			Console.ReadLine();
			return;
		}

		try
		{
			var fulltext = File.ReadAllText(args[0]);
			using(StreamWriter sw = new StreamWriter("整形済.json"))
			{
				var line = "";
				var indent = 0;
				var inquort = false;
				var index = 0;
				foreach(char c in fulltext)
				{
					if(line.Equals(""))
					{
						for(int i = 0; i < indent; i++)
						{
							line += "\t";
						}
					}
					line += c.ToString();
					if(c.ToString().Equals("\""))
					{
						inquort = !inquort;
					}
					if(!inquort)
					{
						if(
							c.ToString().Equals("[")
							||
							c.ToString().Equals("{")
						)
						{
							line = line.Substring(0, line.Length - 1);
							if(!string.IsNullOrWhiteSpace(line)) sw.WriteLine(line);
							line = "";

							for(int i = 0; i < indent; i++)
							{
								line += "\t";
							}
							line += c.ToString();
							sw.WriteLine(line);
							line = "";
							indent++;
						}
						else if(
							c.ToString().Equals("}")
							||
							c.ToString().Equals("]")
						)
						{
							line = line.Substring(0, line.Length - 1);
							if(!string.IsNullOrWhiteSpace(line)) sw.WriteLine(line);
							line = "";
							indent--;

							for(int i = 0; i < indent; i++)
							{
								line += "\t";
							}
							line += c.ToString();

							if(fulltext.Length - 1 > index)
							{
								if(!fulltext[index + 1].ToString().Equals(","))
								{
									sw.WriteLine(line);
									line = "";
								}
							}
							else
							{
								sw.Write(line);
							}
						}
						else if(c.ToString().Equals(","))
						{
							sw.WriteLine(line);
							line = "";
						}
					}
					index++;
				}
			}
		}
		catch (System.Exception)
		{
			throw;
		}
		Console.WriteLine("finished.");
		Console.ReadLine();
	}
}